'From VisualWorks(R), Release 2.5.1 of September 26, 1995 on February 10, 1998 at 6:44:00 am'!



((PlbCustomDeepCopySupport createSubApplication: #PlbVisualWorksGeneralCopySupport in: 'true') isNil)
    ifTrue: [self error: 'Can not proceed since the sub-application was not created']!

PlbVisualWorksGeneralCopySupport becomeDefault!

    "Private Class"
SubApplication subclass: #PlbVisualWorksGeneralCopySupport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''!

PlbVisualWorksGeneralCopySupport becomeDefault!

!Behavior privateMethodsFor: 'copying'!

plbGeneralCopyStructure
	"Behaviors shouldn't generally be copied. Answer
	 the receiver."

	^self! !

!CompiledCode privateMethodsFor: 'copying'!

plbGeneralCopyStructure
	"Compiled code shouldn't generally be copied. Answer
	 the receiver."

	^self! !

!Context privateMethodsFor: 'copying'!

plbGeneralCopyStructure
	"Contexts shouldn't generally be copied. Answer
	 the receiver."

	^self! !

!Number privateMethodsFor: 'copying'!

plbGeneralCopyStructure
	"Answer the receiver because operations on
	 numbers always create new numbers."

	^self! !

!Object publicMethodsFor: 'copying'!

plbGeneralCopy
	"Answer a true deep copy of the receiver while maintaining
	 references. Each referenced object will have the opportunity
	 to participate in the copy and decide how it should be copied."

	| copyStrategy |
	^(copyStrategy := PlbCopyStrategy new)
		structureCopyBlock: [:original | original plbGeneralCopyStructure ];
		contentsCopyBlock: [:original :skeleton | skeleton plbGeneralCopyContentsFrom: original using: copyStrategy ];
		copyRoot: self.! !

!Object privateMethodsFor: 'copying'!

plbGeneralCopyContentsFrom: original using: copyStrategy
	"Populate the variable slots of the receiver with copies of each variable
	 slot of original created under the control of copyStrategy."

	self plbVendorCopyContentsFrom: original using: copyStrategy!

plbGeneralCopyStructure
	"Answer an unpopulated instance like the receiver. This 
	 skeleton instance will later be populated as each referenced
	 variable of the receiver is copied. Answer nil or the receiver
	 if the receiver shouldn't be copied."

	^self plbVendorCopyStructure! !

!PoolDictionary privateMethodsFor: 'copying'!

plbGeneralCopyStructure
	"PoolDictionaries shouldn't generally be copied. Answer
	 the receiver."

	^self! !

!String privateMethodsFor: 'copying'!

plbGeneralCopyStructure
	"Since strings are rarely modified by #at:put:, the
	 general behavior is to just answer the receiver."

	^self! !

!SystemDictionary privateMethodsFor: 'copying'!

plbGeneralCopyStructure
	"The system dictionary shouldn't generally be copied. 
	 Answer the receiver."

	^self! !

PlbVisualWorksGeneralCopySupport initializeAfterLoad!

PlbVisualWorksGeneralCopySupport loaded!
